unit Tourists;

interface

uses Classes, Attracts;


type
  TTourist = class (TAttrVisitor)
  private
    FSatisfaction: Integer;
  public
    property Satisfaction: Integer read FSatisfaction;
  end;

  TBusinessman = class (TTourist)
  public
    constructor Create;
    procedure VisitCycleTour(Instance: TCycleTour); override;
    procedure VisitRedLightsTour(Instance: TRedLightsTour); override;
    procedure VisitTulipsTour(Instance: TTulipsTour); override;
    procedure VisitWindmillTour(Instance: TWindmillTour); override;
  end;

  TStudent = class (TTourist)
  public
    constructor Create;
    procedure VisitCycleTour(Instance: TCycleTour); override;
    procedure VisitRedLightsTour(Instance: TRedLightsTour); override;
    procedure VisitTulipsTour(Instance: TTulipsTour); override;
    procedure VisitWindmillTour(Instance: TWindmillTour); override;
  end;


implementation

uses MMUtils;

{
**************************************** TTourist ****************************************
}
{
************************************** TBusinessman **************************************
}
constructor TBusinessman.Create;
begin
  inherited Create;
  FSatisfaction := -100;
  { Didn't like the meetings he came for at all }
end;

procedure TBusinessman.VisitCycleTour(Instance: TCycleTour);
begin
  Dec(FSatisfaction, 100);
  { Takes too much time }
end;

procedure TBusinessman.VisitRedLightsTour(Instance: TRedLightsTour);
begin
  Inc(FSatisfaction, 1000);
  { Just what he needs. money doesn't matter }
end;

procedure TBusinessman.VisitTulipsTour(Instance: TTulipsTour);
begin
  Dec(FSatisfaction, 250);
  { Not interested at all }
end;

procedure TBusinessman.VisitWindmillTour(Instance: TWindmillTour);
begin
  Inc(FSatisfaction, 75);
  { Quite amusing, liked the stream engines included in the visit }
end;

{
**************************************** TStudent ****************************************
}
constructor TStudent.Create;
begin
  inherited Create;
  FSatisfaction := 500;
  { Is on a grand tour of Europe, and liked it all so far.. }
end;

procedure TStudent.VisitCycleTour(Instance: TCycleTour);
begin
  Inc(FSatisfaction, 500);
  { Very interesting, went to places i'd never imagined to see. }
end;

procedure TStudent.VisitRedLightsTour(Instance: TRedLightsTour);
begin
  Dec(FSatisfaction, 1000);
  { Student is broke now and must sell his ticket home to pay the hotel }
end;

procedure TStudent.VisitTulipsTour(Instance: TTulipsTour);
begin
  Dec(FSatisfaction, 500);
  { Really boring }
end;

procedure TStudent.VisitWindmillTour(Instance: TWindmillTour);
begin
  Inc(FSatisfaction, 75);
  { Quite interesting, but lots of eldery people on the bus }
end;


initialization
end.
