unit dmcRegis;

interface
uses LibMain, dmcBase, dmcBMP, dmcAnim, Classes, DsgnIntf, Dialogs, Forms
        , SysUtils, FileCtrl, dmcEdt1;

type
    TdmcFileEditor = Class(TStringProperty)
        Function  GetAttributes : TPropertyAttributes;  Override;
        Function  GetValue      : String;               Override;
        Procedure Edit;                                 Override;
    end;
    TDirSelectEditor = Class(TStringProperty)
        Function  GetAttributes : TPropertyAttributes;  Override;
        Function  GetValue      : String;               Override;
        Procedure Edit;                                 Override;
    end;

procedure SetActive(ss: string);
procedure Register;

implementation

procedure Register;
begin
    RegisterComponents('Fireworks', [TdmcOption, TdmcMainWindow, TdmcPalette, TdmcWindow]);
    RegisterComponents('Fireworks', [TdmcImage, TdmcAnim, TdmcAnimButton]);
    RegisterComponents('Fireworks', [TdmcAnimFile]);
    RegisterPropertyEditor( TypeInfo(string), TdmcImage,'Image',
      TdmcFileEditor );
    RegisterPropertyEditor( TypeInfo(string), TdmcAnimFile,'Animation',
      TdmcFileEditor );
    RegisterPropertyEditor( TypeInfo(string), TdmcAnimButton,'Sound',
      TdmcFileEditor );

    RegisterPropertyEditor( TypeInfo(string), TdmcOption,'ResourceDir',
      TDirSelectEditor );
    RegisterPropertyEditor( TypeInfo(TStringList), TdmcAnim,'Images',
      TImageFileListEditor );
    RegisterPropertyEditor( TypeInfo(TStringList), TdmcAnimButton,'Images',
      TImageFileListEditor );
end;

function TdmcFileEditor.GetAttributes: TPropertyAttributes;
begin
  Result := inherited GetAttributes +
      [paDialog]-[paSubProperties];
end;

function TdmcFileEditor.GetValue: string;
begin
    result:= GetStrValue;
end;

procedure TdmcFileEditor.edit;
var
    dlg: TOpenDialog;
    ss: string;
begin
    dlg:= TOpenDialog.Create(Application);
    dlg.Filename:= GetStrValue;
    ss:= GetName;
    if ss = 'Image' then
        dlg.Filter:= 'Windows BMP|*.bmp|All Files|*.*'
    else if ss = 'Animation' then
        dlg.Filter:= 'Flic Animation|*.flc;*.fli|All Files|*.*'
    else if ss = 'Sound' then
        dlg.Filter:= 'Wave Files|*.wav|All Files|*.*';

    dlg.InitialDir:= ExtractFilePath(dlg.Filename);
    if dlg.Execute then
        SetStrValue(lowercase(dlg.Filename));
    dlg.free;
end;
{TDirSelectEditor}
function TDirSelectEditor.GetAttributes: TPropertyAttributes;
begin
  Result := inherited GetAttributes +
      [paDialog]-[paSubProperties];
end;

function TDirSelectEditor.GetValue: string;
begin
    result:= GetStrValue;
end;

procedure TDirSelectEditor.edit;
var ss: string;
begin
    ss:=GetStrValue;
    if SelectDirectory(ss, [], 0) then;
        SetStrValue(lowercase(ss));
end;

procedure SetActive(ss: string);
begin
LibMain.CompLib.GetActiveForm.SetSelection(ss);
end;
initialization
@FnSetActive:= Addr(SetActive);
begin

end;
end.
